<template>
  <div class="template">
    <div v-if="sendRequest == false" class="formContainer">
      <form class="form">
        <div class="formElement">
          <label>Prénom</label>
          <input
            id="firstName"
            type="text"
            name="firstName"
            placeholder="Saisissez ici votre prénom"
            @focusout="isFirstNameValid"
            v-model="firstName"
          />
          <p v-if="firstNameError == true">Veuillez entrer un Prénom valide</p>
        </div>
        <div class="formElement">
          <label>Nom</label>
          <input
            id="lastName"
            type="text"
            name="lastName"
            placeholder="Saisissez ici votre nom"
            v-model="lastName"
            @focusout="isLastNameValid"
          />
          <p v-if="lastNameError == true">Veuillez entrer un Nom valide</p>
        </div>
        <div class="formElement">
          <label>Votre adresse mail</label>
          <input
            id="email"
            type="email"
            name="email"
            placeholder="Saisissez ici votre email"
            v-model="email"
            @focusout="isEmailValid"
          />
          <p v-if="emailError == true">Veuillez entrer un email valide</p>
        </div>
        <div class="formElement">
          <label>Mot de passe</label>
          <input
            id="password"
            type="password"
            name="pasword"
            placeholder="Saisissez ici votre mot de passe"
            v-model="password"
            @focusout="isPasswordValid"
          />
          <p v-if="passwordError == true">
            Le mot de passe doit comporter entre 4 et 8 caractères et inclure au moins un chiffre.
          </p>
        </div>
        <div class="formElement">
          <label>Confirmation du mot de passe</label>
          <input
            id="confirmPassword"
            type="password"
            name="pasword"
            placeholder="Confirmer ici votre mot de passe"
            v-model="confirmPassword"
            @focusout="isConfirmPasswordValid"
          />
          <p v-if="confirmPasswordError == true">
            Confirmation du mot de passe incorrecte
          </p>
        </div>

        <div class="formElement">
          <label>Ajouter une photo <span>(format jpeg, jpg ou png)</span></label>
          <input
            type="file"
            accept="image/png, image/jpg, image/jpeg"
            id="urlImage"
            name="attachment" 
            placeholder="Télécharger votre photo"
            @change="uploadFiles($event.target.files)"
          />
        </div>

        <div class="formElement">
          <button
            id="register"
            type="submit"
            @click="register"

            :disabled="validatedFields == false"
          >
            <span v-if="status == 'loading'">Création en cours</span>
            <span v-else>Créer mon compte</span>
          </button>
        </div>
        <div class="form-row" v-if="status == 'error_create'">
          Adresse mail déjà utilisée
        </div>
      </form>
    </div>

    <h1 v-else>Votre compte est créé</h1>
  </div>
</template>

<script>
import { mapState } from "vuex";

export default {
  name: "RegisterForm",
  data() {
    return {
      firstName: "",
      lastName: "",
      email: "",
      password: "",
      attachment: "",
      urlImage: "",
      sendRequest: false,
      account: {},
      regEmail: /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/gim,
      regName: /^[A-zÀ-ÿ-]+[A-zÀ-ÿ-]$/gim,
      regPassword: /^(?=.*\d).{4,8}$/gim,
      firstNameError: "",
      lastNameError: "",
      emailError: "",
      confirmPassword: "",
      passwordError: "",
      confirmPasswordError: "",
    };
  },
  
  computed : {
    validatedFields() {
      if (this.firstNameError == true || this.lastNameError == true || this.emailError == true || this.passwordError == true || this.confirmPasswordError == true) {
      return false
      } else {
        return true
      }
    },
        ...mapState(['status'])
  },

  methods: {
    isFirstNameValid() {
      if (this.firstName !== "" && this.regName.test(this.firstName)) {
        this.firstNameError = false;
      } else {
        this.firstNameError = true;
      }
    },
    isLastNameValid() {
      if (this.lastName !== "" && this.regName.test(this.lastName)) {
        this.lastNameError = false;
      } else {
        this.lastNameError = true;
      }
    },
    isEmailValid() {
      if (this.email !== "" && this.regEmail.test(this.email)) {
        this.emailError = false;
      } else {
        this.emailError = true;
      }
    },
    isPasswordValid() {
      if (this.password !== "" && this.regPassword.test(this.password)) {
        this.passwordError = false;
      } else {
        this.passwordError = true;
      }
    },
    isConfirmPasswordValid() {
      if (this.confirmPassword === this.password) {
        this.confirmPasswordError = false;
      } else {
        this.confirmPasswordError = true;
      }
    },
    uploadFiles(files) {
      this.attachment = files[0];
    },
    getFormData() {
      let formData = new FormData();
      formData.append("attachment", this.attachment);
      formData.append("firstName", this.firstName);
      formData.append("lastName", this.lastName);
      formData.append("email", this.email);
      formData.append("password", this.password);
      return formData;
    },
    register(e) {
      const formData = this.getFormData();
      const self = this;

      e.preventDefault();
      this.$store
        .dispatch(
          "createAccount",
          formData
        )
        .then(
          (response) => {
            console.log(response);
            self.$store
              .dispatch("login", {
                email: self.email,
                password: self.password,
              })
              .then(
                (response) => {
                  console.log(response);
                  self.$router.push("/network");
                },
                function (error) {
                  console.log(error);
                }
              );
          },
          function (error) {
            console.log(error);
          }
        );

    },
  },
};
</script>

<style lang="scss" scoped>
.template {
  background-image: url("../assets/logos/icon.svg");
  background-attachment: fixed;
  background-repeat: no-repeat;
}
.form {
  font-size: large;
  text-align: start;
  &Element {
    display: grid;
    grid-template-columns: 1fr 2fr;
    justify-content: space-around;
    align-items: center;
    margin: 10px;
    padding: 15px;
  }
}
label, input, button {
    display : block;
}
label, p {
  padding-left: 20px;
}
#firstName, #lastName, #email, #password, #confirmPassword, #register {
  border-radius: 40px;
  border: solid 1px blue;
  width: 300px;
  height: 50px;
  font-size: 20px;
  padding-left: 10px;
  &:hover {
    background-color: red;
    color: white;
    font-weight: bold;
  }
}
button {
  background-color: transparent;
  grid-column: 2;
  &:hover {
    background-color: blue;
    color: white;
  }
}
p {
  color: rgb(94, 5, 5);
  font-style : italic;
  font-weight: lighter;
}

@media screen and (max-width: 660px){
    .template {
  padding-top: 150px;
}
  .form{
    display : flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    &Element{
      grid-template-columns: 1fr;
      align-items: center;
      margin:20px;
      padding:10px;
    }
  }
}
</style>
